dcb "INIT"
RTL 

dcb "MAIN"
PHB
PHK
PLB 
JSR SpriteCode
JSL $01A7DC
BCC NoContact

JSL $00F606

NoContact:
PLB
RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Sprite Code;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SpriteCode
JSR Graphics
RTS

;;;;;;;;;;;;;;;;;;;;
;Table
;;;;;;;;;;;;;;;;;;;;

ANIMATION: dcb $C2,$CE


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;ROTINAS DOS GRAPHICOS AQUI;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Graphics 

	JSR GET_DRAW_INFO
	
	LDA $00			;\Indicamos a posio X
	STA $0300,y		;/para o OAM

	LDA $01			;\Indicamos a posio Y
	STA $0301,y		;/para o OAM
	
	PHX
	LDA $13
	LSR
	LSR
	AND #$01
	TAX
	LDA ANIMATION,x	
	STA $0302,y	
	PLX

;;;;;;;;;;YXPPCCCT;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
	LDA #%00000100		;\Aqui poderia ser em bits
	ORA $64			;|mas isto serve para indicar
	STA $0303,y		;/as "caracteristicas do sprite como a paleta, a prioridade e etc
;Y=flipando o sprite na posio Y
;X=flipando o sprite na posio X
;PP=prioridade do sprite, 00  sem, 11  com
;CCC=paleta:
;;;;;;;;;;;;;;;;;
;000 = Palette 8;
;001 = Palette 9;
;010 = Palette A;
;011 = Palette B;
;100 = Palette C;
;101 = Palette D;
;110 = Palette E;
;111 = Palette F;
;;;;;;;;;;;;;;;;;
;T=a pagina de graphicos, 0=SP1/2, 1=SP3/4
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

INY		;\Ns estamos desenhando 
INY		;|1 sprite 8x8
INY		;|entao precisamos de
INY		;/4 tiles 16x16

LDY #$02	;|Ns estamos desenhando 1 tile 16x16 entao  2
LDA #$00	;|Ns estamos desenhando 1 tile, entao aqui  0

JSL $01B7B3	;|Rotina OAM

RTS	;|Depois de 1 longo (ou nem tanto) codigo ns devemos finaliza-lo





;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;GET DRAW INFO AQUI;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;




                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /